# ComponentSelectionCause

enum ComponentSelectionCause

The possible component selection causes. There are a limited number of causes, but each of them can be provided with a custom description, via ComponentSelectionDescriptor.

#### Since

4.6

## Entries

ROOT
Link copied to clipboard
ROOT

This component was selected because it's the root component.

REQUESTED
Link copied to clipboard
REQUESTED

This component was selected because it was requested directly.

SELECTED_BY_RULE
Link copied to clipboard
SELECTED_BY_RULE

This component was selected by a rule.

FORCED
Link copied to clipboard
FORCED

This component was selected because selection was forced on this version.

CONFLICT_RESOLUTION
Link copied to clipboard
CONFLICT_RESOLUTION

This component was selected between several candidates during conflict resolution.

COMPOSITE_BUILD
Link copied to clipboard
COMPOSITE_BUILD

This component was selected as a participant of a composite.

REJECTION
Link copied to clipboard
REJECTION

This component was selected because another version was rejected by a rule

CONSTRAINT
Link copied to clipboard
CONSTRAINT

This component was selected because of a dependency constraint

BY_ANCESTOR
Link copied to clipboard
BY_ANCESTOR

This component was selected because it was requested by a parent with a strict version.

## Properties

defaultReason
Link copied to clipboard
val defaultReason: String

## Functions

valueOf
Link copied to clipboard
open fun valueOf(name: String): ComponentSelectionCause

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

values
Link copied to clipboard
open fun values(): Array<ComponentSelectionCause>

Returns an array containing the constants of this enum type, in the order they're declared. This method may be used to iterate over the constants.